
alliance_flag_home=1;
horde_flag_home=1;
BGGRating = {{0,0,0,0},{0,0,0}};
FCDead=0;
FCName=nil;
PlayerFaction=nil;

FCAssistRadius = 40;

--WSG Message Definitions--
msgAllianceFlagPickedUp = "The Alliance Flag was picked up by";
msgHordeFlagPickedUp = "The Horde flag was picked up by";

--msgAllianceFlagDropped = "The Alliance Flag was dropped by";
--msgHordeFlagDropped = "The Horde flag was dropped by";
msgFlagDropped = "was dropped by";

msgAllianceFlagReturned = "The Alliance Flag was returned to its base by";
msgHordeFlagReturned = "The Horde flag was returned to its base by";

msgAllianceFlagCaptured = "";
msgHordeFlagCaptured = "";

--Arathi Basin Message Definitions--

function BGGladiator_OnLoad()
	this:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
	this:RegisterEvent("ChAT_MSG_BG_SYSTEM_ALLIANCE");
	this:RegisterEvent("PLAYER_DEAD");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");

	MakeBabies();
end

function MakeBabies()

	local backdrop = {	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
				edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
				tile = true, tileSize = 8, edgeSize = 16,
				insets = {left = 0, right =0, top =0, bottom = 0}
			};
	
	topFrame = CreateFrame("Frame","BGGlad",UIParent);
	topFrame:SetBackdrop(backdrop);
	topFrame:SetPoint("CENTER");
	topFrame:SetWidth(300);  
	topFrame:SetHeight(100); 
	topFrame:SetBackdropColor(0.2, 0.2, 0.2, 0.7);

	topFrame:EnableMouse(1);
	topFrame:SetMovable(1);
	topFrame:RegisterForDrag("LeftButton");
	topFrame:SetScript("OnDragStart", function() topFrame:StartMoving() end);
	topFrame:SetScript("OnDragStop", function() topFrame:StopMovingOrSizing() end);

	fsTitle = topFrame:CreateFontString("Title","OVERLAY");
	fsTitle:SetFontObject(GameFontNormal);
	fsTitle:SetPoint("TOPLEFT", 5, -5);
	fsTitle:SetText("BG Gladiator v1.0 by Salanex");

	fsWSGTitle = topFrame:CreateFontString("WSGTitle","OVERLAY");
	fsWSGTitle:SetFontObject(GameFontNormal);
	fsWSGTitle:SetPoint("TOPLEFT", 5, -25);
	fsWSGTitle:SetText("Warsong Gulch Ratings");

	fsWSGRating = topFrame:CreateFontString("WSGRating","OVERLAY");
	fsWSGRating:SetFontObject(GameFontNormal);
	fsWSGRating:SetPoint("TOPLEFT", 5, -40);

	fsZoneCoords = topFrame:CreateFontString("ZoneCoords","OVERLAY");
	fsZoneCoords:SetFontObject(GameFontNormal);
	fsZoneCoords:SetPoint("TOPRIGHT",topFrame,"TOPRIGHT", -5,-5);

	fsABTitle = topFrame:CreateFontString("ABTitle","OVERLAY");
	fsABTitle:SetFontObject(GameFontNormal);
	fsABTitle:SetPoint("TOPLEFT", 5, -60);
	fsABTitle:SetText("Arathi Basin Ratings");

	fsABRating = topFrame:CreateFontString("ABRating","OVERLAY");
	fsABRating:SetFontObject(GameFontNormal);
	fsABRating:SetPoint("TOPLEFT", 5, -75);

	topFrame:Show();
	
end

function BGGladiator_OnEvent()
	
	local PlayerLoc = PlayerLocation();

	if(event=="PLAYER_ENTERING_WORLD") then
		PlayerFaction = UnitFactionGroup("player");
	end
	if(event=="PLAYER_PVP_KILLS_CHANGED") then
		EnemyKilled(PlayerLoc);		
	end
	if(event=="CHAT_MSG_BG_SYSTEM_ALLIANCE") then
		--"captured the Alliance Flag"
		--"captured the Horde Flag"

		if(string.find(arg1,msgHordeFlagPickedUp,1)~=nil and horde_flag_home==1) then --friendly flag was picked up at friendly base
			HordeFlagPickedUp(arg1, PlayerLoc);
		end 
		if(string.find(arg1, msgFlagDropped,1)~=nil) then --some nub dropped the enemy flag
			FlagDropped();
		end		
		if(string.find(arg1, msgAllianceFlagReturned,1)~=nil) then --used to reset the flag whereabouts status
			AllianceFlagReturned(arg1);
		end
	end
	if(event=="CHAT_MSG_BG_SYSTEM_HORDE") then 
		if(string.find(arg1,msgHordeFlagReturned,1)~=nil) then --used to reset the flag whereabouts status
			HordeFlagReturned(arg1);
		end
		if(string.find(arg1, msgAllianceFlagPickedUp, 1)~=nil) then --successfully assaulted the enemy flag
			AllianceFlagPickedUp(arg1, PlayerLoc);
		end
		if(string.find(arg1, msgFlagDropped,1)~=nil) then
			FlagDropped();
		end
	end
	if(event=="PLAYER_DEAD") then
		PlayerDied(PlayerLoc);
	end
	if(event=="CHAT_MSG_BG_SYSTEM_NEUTRAL") then
		horde_flag_home=1;
		alliance_flag_home=1;
		FCDead=0;
		FCName=nil;
	end
	if(event=="VARIABLES_LOADED") then
		BGGRating = BGGRating; -- or {{0,0,0,0},{0,0,0}};
	end

	CheckRatings();
	Update_Frame();
end

function GetEventPlayer(event_msg)
	local msg_len = string.len(event_msg);
	local event_flag=0
	

	s_start,s_end = string.find(event_msg,msgHordeFlagReturned,1);
	if(s_start~=nil) then
		str_start=s_end+2;
		str_end=msg_len-1;	
		event_flag=1;
	end

	s_start,s_end = string.find(event_msg,msgAllianceFlagReturned,1);
	if(s_start~=nil) then
		str_start=s_end+2;
		str_end=msg_len-1;	
		event_flag=1;
	end

	s_start,s_end = string.find(event_msg,msgHordeFlagPickedUp,1);
	if(s_start~=nil) then
		str_start=s_end+2;
		str_end=msg_len-1;	
		event_flag=1;
	end

	s_start,s_end = string.find(event_msg,msgAllianceFlagPickedUp,1);
	if(s_start~=nil) then
		str_start=s_end+2;
		str_end=msg_len-1;	
		event_flag=1;
	end

	if(event_flag==1) then
		return string.sub(event_msg,str_start,str_end);
	else
		return "William H. Random";
	end
end

function EnemyKilled(PlayerLoc)
		if(PlayerLoc=="HFR" and horde_flag_home==1) then 
			if(PlayerFaction=="Horde") then
				BGGRating[1][1]=BGGRating[1][1] + 1; --Horde defensive award
			else
				BGGRating[1][2]=BGGRating[1][2] + 1; --Alliance offensive award
			end
		elseif (PlayerLoc=="AFR" and alliance_flag_home==1) then
			if(PlayerFaction=="Horde") then
				BGGRating[1][2]=BGGRating[1][2]+1; --Horde offensive award
			else
				BGGRating[1][1]=BGGRating[1][1]+1; --Alliance defensive award
			end
		elseif(IsNearFC()==1 and UnitName("player")~=FCName) then
			BGGRating[1][4] = BGGRating[1][4] + 1; --FC Assist award
		end
end

function HordeFlagPickedUp(arg1, PlayerLoc)
	if(PlayerFaction=="Horde") then
		BGGRating[1][1] = BGGRating[1][1] - 1; --Horde defensive penalty
		if(PlayerLoc=="Midfield") then
			BGGRating[1][3] = BGGRating[1][3] -1 ; --Horde control penalty
		end
	else
		FCName = GetEventPlayer(arg1); --Set Alliance FC Name	
		if(horde_flag_home==1) then
			if(PlayerLoc=="HFR") then
				BGGRating[1][2] = BGGRating[1][2] + 1; --Alliance offensive award
			end
			if(PlayerLoc=="Midfield") then
				BGGRating[1][3] = BGGRating[1][3] + 1 ; --Alliance control award
			end
		else
			if(FCDead==1 and UnitName("player")==FCName) then
				SendChatMessage("Debug - I saved the flag", "SAY");
				BGGRating[1][1] = BGGRating[1][1] + 1;				
			end
		end
		FCDead=0;				
	end
	horde_flag_home=0;
end

function AllianceFlagPickedUp(arg1, PlayerLoc)
	if(PlayerFaction=="Horde") then
		FCName=GetEventPlayer(arg1);
		if(alliance_flag_home==1) then
			if(PlayerLoc=="AFR") then
				BGGRating[1][2] = BGGRating[1][2] + 1;
			elseif(PlayerLoc=="Midfield") then
				BGGRating[1][3] = BGGRating[1][3] + 1;
			end
		else	
			if(FCDead==1 and UnitName("player")==FCName) then
				SendChatMessage("Debug - I saved the flag", "SAY");
				BGGRating[1][1] = BGGRating[1][1] + 1;
			end
		end
		FCDead=0;
	else
		BGGRating[1][1] = BGGRating[1][1] - 1; --Alliance defensive penalty
		if(PlayerLoc=="Midfield") then
			BGGRating[1][3] = BGGRating[1][3] - 1; --Alliance control penalty
		end
	end
	alliance_flag_home=0;
end

function FlagDropped()
	if(PlayerIsDead(FCName)==1) then
			FCDead=1;
	end
	FCName=nil;			
end

function AllianceFlagReturned(arg1)
	if(PlayerFaction=="Horde") then	
			FCDead=0;
			if(UnitName("player")~=FCName) then
				BGGRating[1][4] = BGGRating[1][4] - 1; --Assist penalty for the whole team except FC
			end
	else
		if(UnitName("player")==GetEventPlayer(arg1)) then
			BGGRating[1][1] = BGGRating[1][1] + 1; -- Alliance defensive award
			SendChatMessage("Debug - I returned our flag", "SAY");			
		end
	end
	alliance_flag_home=1;
end

function HordeFlagReturned(arg1)
	if(PlayerFaction=="Horde") then
		if(UnitName("player")==GetEventPlayer(arg1)) then
			BGGRating[1][1] = BGGRating[1][1] + 1; -- returned flag to base
			SendChatMessage("Debug - I returned our flag", "SAY");
		end
	else
		FCDead=0;
		if(UnitName("player")~=FCName) then
			BGGRating[1][4] = BGGRating[1][4] - 1; --Assist penalty for the whole team except FC
		end			
	end
	horde_flag_home=1;		
end

function PlayerDied()
	if(PlayerFaction=="Horde") then
		if(PlayerLoc=="HFR" and horde_flag_home==1) then --died in horde flag room
			BGGRating[1][1]=BGGRating[1][1] - 1;
		elseif(PlayerLoc=="AFR" and alliance_flag_home==1) then
			BGGRating[1][2] = BGGRating[1][2] - 1;
		elseif(IsNearFC()==1 and UnitName("player")~=FCName) then
			BGGRating[1][4] = BGGRating[1][4] - 1; --Near FC when dying is an assist penalty
		end	
	else
		if(PlayerLoc=="HFR" and horde_flag_home==1) then --died in horde flag room
			BGGRating[1][2]=BGGRating[1][2] - 1;
		elseif(PlayerLoc=="AFR" and alliance_flag_home==1) then
			BGGRating[1][1] = BGGRating[1][1] - 1;
		elseif(IsNearFC()==1 and UnitName("player")~=FCName) then
			BGGRating[1][4] = BGGRating[1][4] - 1; --Near FC when dying is an assist penalty
		end	
	end
end

function CheckRatings()
	if(BGGRating[1][1]>50) then
		BGGRating[1][1]=50;	
	elseif(BGGRating[1][1]<-50) then
		BGGRating[1][1]=-50;	
	end

	if(BGGRating[1][2]>50) then
		BGGRating[1][2]=50;	
	elseif(BGGRating[1][2]<-50) then
		BGGRating[1][2]=-50;	
	end

	if(BGGRating[1][3]>50) then
		BGGRating[1][3]=50;	
	elseif(BGGRating[1][3]<-50) then
		BGGRating[1][3]=-50;	
	end

	if(BGGRating[1][4]>50) then
		BGGRating[1][4]=50;	
	elseif(BGGRating[1][4]<-50) then
		BGGRating[1][4]=-50;	
	end
end

function PlayerIsDead(player_name)
	NumPlayers = GetNumRaidMembers();
	for i=1, NumPlayers do
		name,_,_,_,_,_,_,_,dead = GetRaidRosterInfo(i);
		if(name==player_name and dead==1) then
			SendChatMessage(player_name.." died while carrying flag", "GUILD");
			return 1;
		end
	end
	return 0;
end

function EuclideanDistance(x1, y1, x2, y2)
	x = math.floor(x2 - x1);
	y = math.floor(y2 - y1);
	xs = x * x;
	ys = y * y;
	zs = xs + ys;
	z = math.floor(math.sqrt(zs));
	--SendChatMessage("Distance: "..z.." - x: "..x.." - y: "..y, "GUILD");
	return z;	
end

function IsNearFC()

	if(FCName~=nil) then
		local x1,y1 = GetPlayerMapPosition("player");
		local x2,y2 = RaidMemberLocation(FCName);
		x1 = math.floor(x1 * WorldMapDetailFrame:GetWidth());
		y1 = math.floor(y1 * WorldMapDetailFrame:GetHeight());
		if(EuclideanDistance(x1, y1, x2, y2)<FCAssistRadius) then
			return 1;
		end 
	end
	return 0;		
end

function RaidMemberLocation(player_name)
	NumPlayers = GetNumRaidMembers()
	for i=1, NumPlayers do
		name = GetRaidRosterInfo(i);
		if(name==player_name) then
			local x,y = GetPlayerMapPosition("raid" .. i);
			x = math.floor(x * WorldMapDetailFrame:GetWidth());
			y = math.floor(y * WorldMapDetailFrame:GetHeight());
			return x,y;
		end
	end
end

function PlayerLocation()
	HFR = {["LEFT"]=50, ["RIGHT"]=55, ["TOP"]=50, ["BOTTOM"]=62}
	AFR = {["LEFT"]=44, ["RIGHT"]=52, ["TOP"]=8, ["BOTTOM"]=14}

	x,y = GetPlayerMapPosition("player");
	x = math.floor(x * WorldMapDetailFrame:GetWidth())/10;
	y = math.floor(y * WorldMapDetailFrame:GetHeight())/10;

	if(x>=HFR["LEFT"] and x<=HFR["RIGHT"] and y>=HFR["TOP"] and y<=HFR["BOTTOM"]) then
		return "HFR";
	elseif(x>=AFR["LEFT"] and x<=AFR["RIGHT"] and y>=AFR["TOP"] and y<=AFR["BOTTOM"]) then
		return "AFR";
	elseif(GetMinimapZoneText()=="Warsong Gulch") then
		return "Midfield";
	else
		return "NFI";
	end
end

function Update_Frame()
	if(fsWSGRating~=nil and fsABRating~=nil) then
		fsWSGRating:SetText("Offensive: "..BGGRating[1][2].."  Defense: "..BGGRating[1][1].."  Control: "..BGGRating[1][3].."  Assist: "..BGGRating[1][4]);
		fsABRating:SetText("Offense: "..BGGRating[2][2].."  Defense: "..BGGRating[2][1].."  Ninja: "..BGGRating[2][3]);
	end
end

function DisplayRating()
	SendChatMessage("WSG: Off "..BGGRating[1][2].." - Def "..BGGRating[1][1].." - Cont "..BGGRating[1][3], "GUILD");
end

function BGG_Handler(cmd)
	if(cmd=="dr") then
		DisplayRating();
	elseif(cmd=="reset") then
		BGGRating[1][2]=0;
		BGGRating[1][1]=0;
		BGGRating[1][3]=0;
		BGGRating[1][4]=0;
		Update_Frame();
	elseif(cmd=="co") then
		x,y=GetPlayerMapPosition("player");
		x=math.floor(x * WorldMapDetailFrame:GetWidth())/10;
		y=math.floor(y * WorldMapDetailFrame:GetHeight())/10;
		fsZoneCoords:SetText(x..","..y);
	elseif(cmd=="hide") then
		topFrame:Hide();
	elseif(cmd=="show") then
		topFrame:Show();
	elseif(cmd=="mark") then
		x,y = GetPlayerMapPosition("player");
		mark_x=math.floor(x * WorldMapDetailFrame:GetWidth());
		mark_y=math.floor(y * WorldMapDetailFrame:GetHeight());		
	elseif(cmd=="plot") then
		x,y = GetPlayerMapPosition("player");
		end_x=math.floor(x * WorldMapDetailFrame:GetWidth());
		end_y=math.floor(y * WorldMapDetailFrame:GetHeight());		
		distance=EuclideanDistance(mark_x,mark_y,end_x,end_y);
		fsZoneCoords:SetText("Distance: "..distance);
	end
end

SLASH_BGGLADIATOR1 = "/bgg"
SlashCmdList["BGGLADIATOR"] = BGG_Handler;